import { Space, Table, Button, Popconfirm, notification, Divider, Checkbox, Spin } from 'antd';
import React, { useState, useEffect } from 'react';
import styles from '../SchemeConfig.less'
import {
    PlusOutlined
} from '@ant-design/icons';
import {
    deleteConfig, GetAllConfig, setServiceType, SetServiceConfig
} from '@/services/webConfig/api';
import {
    UserAddOutlined
} from '@ant-design/icons';
import AddModal from './AddModal'
import { set } from 'immutable';
const VectorData = props => {
    const [treeLoading, setTreeLoading] = useState(false);// 弹窗显示
    const [schemename, setSchemename] = useState([]);
    const [webData, setWebData] = useState([]); // web数据
    const [handData, setHandData] = useState([]); //手持数据
    const [visible, setVisible] = useState(false); // 弹窗
    const [flag, setFlag] = useState(0); // 更新list
    const [handStatus, setHandStatus] = useState([]); // 更新状态
    const [webStatus, setWebStatus] = useState([]); // 更新状态
    const [webIndex, setWebIndex] = useState(0); // web默认选中状态
    const [handIndex, setHandIndex] = useState(0); // 手持默认选中状态
    const [type, setType] = useState('add'); // 弹窗类型
    const [checkLoading, setCheckLoading] = useState(false)
    const [solutionNames, setSolutionNames] = useState('');
    const [formObj, setFormObj] = useState({ user: 'admin', password: 'geoserver' });
    const columns = [
        {
            title: '默认方案',
            align: 'center',
            key: 'url',
            render: (text, record, index) => (
                <Space>
                    <Checkbox
                        checked={webStatus[index]}
                        onChange={e => {
                            onChangeCheck(e, record, index);
                        }}
                    />
                </Space>
            ),
        },
        {
            title: '方案名',
            dataIndex: 'schemename',
            key: 'schemename',
            align: 'center'
        },
        {
            title: '关联角色',
            align: 'center',
            key: 'type',
            render: (text, record, index) => (
                <Space>
                    <div onClick={e => e.stopPropagation()}  style={{cursor:'pointer'}}>
                        <UserAddOutlined />
                    </div>
                </Space>
            ),
        },
        {
            title: '编辑',
            align: 'center',
            key: 'schemename',
            render: (text, record, index) => (
                <Space>
                    <div onClick={e => e.stopPropagation()}>
                        <Popconfirm
                            title="是否删除此条方案？"
                            okText="确认"
                            cancelText="取消"
                            onConfirm={() => {
                                delWebConfirm(record);
                            }}
                        >
                            <Button size="small" danger>
                                删除
                            </Button>
                        </Popconfirm>
                    </div>
                </Space>
            ),
        }

    ];
    const columns1 = [
        {
            title: '查询方案',
            align: 'center',
            key: 'url',
            render: (text, record, index) => (
                <Space>
                    <Checkbox
                        checked={handStatus[index]}
                        onChange={e => {
                            onChangeHand(e, record, index);
                        }}
                    />
                </Space>
            ),
        },
        {
            title: '方案名',
            dataIndex: 'schemename',
            key: 'schemename',
            align: 'center'
        },
        {
            title: '关联角色',
            align: 'center',
            key: 'type',
            render: (text, record, index) => (
                <Space>
                    <div onClick={e => e.stopPropagation()} style={{cursor:'pointer'}}>
                        <UserAddOutlined  />
                    </div>
                </Space>
            ),
        },
        {
            title: '编辑',
            align: 'center',
            key: 'schemename',
            render: (text, record, index) => (
                <Space>
                    <div onClick={e => e.stopPropagation()}>
                        <Popconfirm
                            title="是否删除此条方案？"
                            okText="确认"
                            cancelText="取消"
                            onConfirm={() => {
                                delhandConfirm(record);
                            }}
                        >
                            <Button size="small" danger>
                                删除
                            </Button>
                        </Popconfirm>
                    </div>
                </Space>
            ),
        }

    ];
    //设置web方案
    const onChangeCheck = (e, record, index) => {
        setCheckLoading(true)
        const newLoadings = [...webStatus];
        newLoadings.map((item, loadIndex) => {
            return loadIndex == index ? newLoadings[loadIndex] = !newLoadings[loadIndex] : newLoadings[loadIndex] = false
        })
        setWebStatus(newLoadings)
        let query = {
            schemename: record['schemename'],
            type: 'dynamic'
        }
        if (!newLoadings[index]) {
            setServiceType(query).then(res => {
                setCheckLoading(false)
                if (res.IsSuccess) {
                    const changehandData = [...webData];
                    changehandData[index].type = 'dynamic'
                    setWebData(changehandData)
                    prompt('success', '设置成功')
                } else {
                    prompt('fail', `${record['schemename']}默认设置时遇到错误：` + res.message)
                }

            })
            return
        }
        var beforeDefault = webData.findIndex((item) => item['type'] == 'pipenet');
        setServiceType({
            schemename: record['schemename'],
            type: 'pipenet'
        }).then(res => {
            setCheckLoading(false)
            if (res.IsSuccess) {
                const changehandData = [...webData];
                changehandData[index].type = 'pipenet'
                setWebData(changehandData)
                if (beforeDefault != -1) {
                    setServiceType({
                        schemename: changehandData[beforeDefault].schemename,
                        type: 'dynamic'
                    }).then(res => {
                        setCheckLoading(false)
                        if (res.IsSuccess) {
                            const changehandData1 = [...webData];
                            changehandData1[beforeDefault].type = 'dynamic'
                            setWebData(changehandData1)
                            prompt('success', '设置成功')
                            return;
                        }
                        prompt('fail', `${record['schemename']}默认设置时遇到错误：` + res.message)
                    })
                }
            }
        })
    }


    //选择手持方案
    const onChangeHand = (e, record, index) => {
        setCheckLoading(true)
        const newLoadings = [...handStatus];
        newLoadings.map((item, loadIndex) => {
            return loadIndex == index ? newLoadings[loadIndex] = !newLoadings[loadIndex] : newLoadings[loadIndex] = false
        })
        setHandStatus(newLoadings)
        let query = {
            schemename: record['schemename'],
            terminalType: 'phone',
            isBaseMap: false,
            jsonCfg: JSON.stringify({
                isDefault: newLoadings[index],
            })
        }
        if (!newLoadings[index]) {
            SetServiceConfig(query).then(res => {
                setCheckLoading(false)
                if (res.IsSuccess) {
                    const changehandData = [...handData];
                    changehandData[index].isDefault = false
                    setHandData(changehandData)
                    prompt('success', '设置成功')
                } else {
                    prompt('fail', `${record['schemename']}默认设置时遇到错误：` + res.message)
                }

            })
            return
        }
        var beforeDefault = handData.findIndex((item) => item['isDefault']);
        SetServiceConfig({
            schemename: record['schemename'],
            terminalType: 'phone',
            isBaseMap: false,
            jsonCfg: JSON.stringify({
                isDefault: true,
            })
        }).then(res => {
            setCheckLoading(false)
            if (res.IsSuccess) {
                const changehandData = [...handData];
                changehandData[index].isDefault = true
                setHandData(changehandData)
                if (beforeDefault != -1) {
                    SetServiceConfig({
                        schemename: changehandData[beforeDefault].schemename,
                        terminalType: 'phone',
                        isBaseMap: false,
                        jsonCfg: JSON.stringify({
                            isDefault: false,
                        })
                    }).then(res => {
                        setCheckLoading(false)
                        if (res.IsSuccess) {
                            const changehandData1 = [...handData];
                            changehandData1[beforeDefault].isDefault = false
                            setHandData(changehandData1)
                            prompt('success', '设置成功')
                            return;
                        }
                        prompt('fail', `${record['schemename']}默认设置时遇到错误：` + res.message)
                    })
                }
            }
        })
    }
    const prompt = (type, content) => {
        if (type == 'success') {
            notification.success({
                message: '提示',
                duration: 3,
                description: content,
            });
        }
        else {
            notification.error({
                message: '提示',
                duration: 3,
                description: content,
            });
        }
    }
    const onSubmit = prop => {
        setVisible(false);
        setFlag(flag + 1)
    };
    //删除web配置方案
    const delWebConfirm = (record) => {
        deleteConfig({
            schemename: record['schemename'],
            terminalType: 'web',
            isBaseMap: false
        }).then(res => {
            if (res.IsSuccess) {
                prompt('success', '删除成功')
                setFlag(flag + 1)

            } else {
                prompt('fail', '删除失败')
            };
        })
    }
    //删除手持配置方案
    const delhandConfirm = (record) => {
        deleteConfig({
            schemename: record['schemename'],
            terminalType: 'phone',
            isBaseMap: false
        }).then(res => {
            if (res.IsSuccess) {
                prompt('success', '删除成功')
                setFlag(flag + 1)

            } else {
                prompt('fail', '删除失败')
            };
        })
    }
    //添加方案
    const addType = (type) => {
        setType(type);
        let listData = []
        type == 'add' ? listData = webData : listData = handData
        let webSchemenameArr = [], schemeArr = []
        setTreeLoading(true);
        GetAllConfig({
            terminalType: 'scheme',
            isBaseMap: false
        }).then(
            res => {
                if (res && res.Result.length > 0) {
                    setTreeLoading(false);
                    listData.map(item => {
                        webSchemenameArr.push(item.schemename)
                    })
                    res.Result.map(item => {
                        if (!webSchemenameArr.includes(item.schemename))
                            schemeArr.push(item.schemename)
                    })
                    setSchemename(schemeArr)
                    if (schemeArr.length) {
                        setVisible(true);
                    }
                    else {
                        notification.warning({
                            message: '提示',
                            duration: 3,
                            description: '请先配置方案',
                        });
                    }


                } else {
                    setTreeLoading(false);
                    notification.warning({
                        message: '提示',
                        duration: 3,
                        description: '请先配置方案',
                    });
                }
            }
        )
    }
    useEffect(() => {
        renderTile();
    }, [flag]);
    // 获取瓦片数据配置数据
    const renderTile = () => {
        setTreeLoading(true);
        //查询手持方案
        var schemeConfigQueryRequest = GetAllConfig({
            terminalType: 'phone',
            isBaseMap: false
        })
        //查询web方案
        var webSchemeQueryRequest = GetAllConfig({
            terminalType: 'web',
            isBaseMap: false
        })
        Promise.all([schemeConfigQueryRequest, webSchemeQueryRequest]).then(res => {
            console.log('res', res)
            if (res[0].IsSuccess) {
                let arr = []
                res[0].Result.map((item, index) => {
                    if (item.isDefault) {
                        arr.push(true)
                        setHandIndex(index)
                    } else {
                        arr.push(false)
                    }

                    item.isStatus = 'hand'
                    return item
                })
                setHandData(res[0].Result)
                setHandStatus(arr)

            }
            if (res[1].IsSuccess) {
                let arr = []
                res[1].Result.map((item, index) => {
                    if (item.type === "pipenet") {
                        arr.push(true)
                        setWebIndex(index)
                    } else {
                        arr.push(false)
                    }
                    item.isStatus = 'web'
                    return item
                })
                setWebData(res[1].Result)
                setWebStatus(arr)
            }
        })

    };



    return (
        <>
            <Spin tip="loading..." spinning={checkLoading}>
                <div>
                    <div >
                        <Divider orientation="left"><div className={styles.divider}> Web <PlusOutlined
                            onClick={() => { addType('add') }}
                            className={styles.dividerIcon} /></div></Divider>
                        <Table
                            columns={columns}
                            dataSource={webData}
                            bordered
                            pagination={{
                                showTotal: (total, range) =>
                                    `第${range[0]}-${range[1]} 条/共 ${total} 条`,
                                defaultPageSize: 3,

                            }}
                            rowKey="schemename"
                            scroll={{ y: 400 }}
                        >
                        </Table>
                    </div>
                    <Divider orientation="left"><div className={styles.divider}>手持 <PlusOutlined
                        onClick={() => { addType('addHand') }}
                        className={styles.dividerIcon} /></div> </Divider>
                    <Table
                        columns={columns1}
                        dataSource={handData}
                        bordered
                        rowKey="schemename"
                        scroll={{ y: 400 }}
                        pagination={{
                            showTotal: (total, range) =>
                                `第${range[0]}-${range[1]} 条/共 ${total} 条`,
                            defaultPageSize: 3,

                        }}
                    >
                    </Table>
                </div>
            </Spin>
            <AddModal
                visible={visible}
                onCancel={() => setVisible(false)}
                callBackSubmit={onSubmit}
                type={type}
                formObj={formObj}
                listData={schemename}
            />
        </>
    )
}
export default VectorData